// -----------------------------------------------------------------------------
//  CCE_Circle.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// realizzazione della classe per l'elemento cerchio

#import		"CCE_Circle.h"

#import		"CoverView.h"

@implementation CCE_Circle

// ---------------------------------------------------------------------
// per inizializzare mi serve l'immagine e il punto da dove disegnare
- (id)
initWithId: (int) ident inView: (CoverView*) cv withRect: (NSRect) aRect andAngle: (float) angle
{
	self = [ super initWithId: ident inView: cv withRect: aRect andAngle: angle ] ;
	if ( self )
	{
		// aggiusto il path perche' sia un cerchio
		[ self setTheDrawPath: [NSBezierPath bezierPathWithOvalInRect:
			NSMakeRect( 0, 0, localSize.width, localSize.height) ]];
	}
	return self ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
buildMeFromPt: (NSPoint) stPt withSize: (NSSize) dim
{
	NSRect  aRect ;
	[ super buildMeFromPt: stPt withSize: dim ] ;
	aRect = NSMakeRect( 0, 0, localSize.width, localSize.height );
	[ self setTheDrawPath: [NSBezierPath bezierPathWithOvalInRect: aRect ] ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// stringa che descrive l'elemento
- (NSString*)
describeMe
{
	return ( [ NSString stringWithFormat:@"Circle Elem ID %d", [ self objID] ] );
}

@end
