// -----------------------------------------------------------------------------
//  CCE_ElemGroup.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// interfaccia della classe che modella un gruppo di elementi

#import 	<Foundation/Foundation.h>

#import		"CCE_BasicForm.h"
#import		"CCE_Line.h"
#import		"CCE_Rect.h"
#import		"CCE_Text.h"
#import		"CCE_Circle.h"
#import		"CCE_Image.h"

@interface CCE_ElemGroup : CCE_BasicForm
{
	// il vettore degli elementi raggruppati
	NSMutableArray		* elemArray ;
}
// i soliti metodi comuni
- (id)		initWithId: (int) ident inView: (CoverView*) cv ;
- (id)		init ;
- (void)	dealloc ;
- (void)	specificDrawing: (NSRect) inRect ;
- (void)	adaptModification ;

// per aggiungere un elemento al gruppo
- (void)	addElem: (CCE_BasicForm *) elem atIndex: (int) i;
- (void)	remElemAtIndex: (int) i ;
// gestione specifica dei gruppi
- (void)	sendElemFrontAndBack: (int) howMuch;
- (void)	moveSelectedElements: (NSPoint) distance ;
- (void)	rotateElemAngle: (float) angle absolute: (BOOL) absInc ;
- (void)	cascadeSelection:(BOOL)newIsSelected ;
// creazione e distruzione gruppi
- (NSMutableArray *) getSelectedGraphics;
- (void)	ungroupAndInsertIn: (CCE_ElemGroup *) masterArray startingFrom: (int) idx ;
- (void)	makeGroupFromSelected ;
// metodi per la gestione dello undo
- (void)	moveElem: (CCE_BasicForm*) elem by: (NSPoint) distance ;
- (void)	resizeElem: (CCE_BasicForm*) elem withSize: (NSSize) newSize ;
- (void)	changeElem: (CCE_BasicForm*) elem attrib: (int) quale value: (id) valore  ;
- (void)	rotateElem: (CCE_BasicForm*) elem byAngle: (float) angle ;
// cambio del font
- (void)	changeFont:(id)sender ;
// debug
- (void)	printMeWithLevel: (int) lev ;

- (void)	setCceIsLocked:(BOOL)newVal ;
// accessor
- (NSMutableArray *)elemArray;
- (void)setElemArray:(NSMutableArray *)newElemArray;

@end
