// -----------------------------------------------------------------------------
//  CCE_Rect.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// realizzazione della classe per il disegno di un rettangolo

#import		"CCE_Rect.h"

#import		"CoverView.h"

@implementation CCE_Rect

// ---------------------------------------------------------------------
// per inizializzare mi serve il rettangolo
- (id)
initWithId: (int) ident inView: (CoverView*) cv withRect: (NSRect) aRect andAngle: (float) angle
{
	self = [ super initWithId: ident inView: cv ] ;
	if ( self )
	{
		// uso l'origine di aRect come punto di partenza
		[ self setRotAngle: angle ] ;
		[ self buildMeFromPt: aRect.origin withSize: aRect.size ];
	}
	return self ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// costruzione del rettangolo tramite punto base e dimensioni
- (void)
buildMeFromPt: (NSPoint) stPt withSize: (NSSize) dim
{
	// stPt sono le coordinate (view) del punto base
	// dim e' la distanza (locale) del secondo punto da stPt
	NSRect  aRect ;
	// trasformo le distanze in coordinate locali
	localSize = dim ;
	// imposto il nuovo punto iniziale di disegno
	drawPoint = stPt ;
	// l'angolo di rotazione non cambia
	// aggiorno la trasformazione delle coordinate
	[ self calcLocalTranform ];
	// rettangolo che costuisce l'elemento
	aRect = NSMakeRect( 0, 0, localSize.width, localSize.height );
	// per mia convenienza conservo il percorso
	[ self setTheDrawPath: [NSBezierPath bezierPathWithRect: aRect ] ];
	// metto a posto il rettangolo che lo contiene
	[ self buildHdlList ] ;
	[ ownerView setNeedsDisplay: YES ];
}

// ---------------------------------------------------------------------
// devo disegnare il rettangolo
- (void)
specificDrawing: (NSRect) inRect
{
	// disegno del contorno
	if ( cceIsStroked )
	{
		// imposto il colore del contorno
		[ cceLineColor set ];
		// imposto lo spessore del contorno
		[ theDrawPath setLineWidth: [ self cceLineWidth ]];
		// disegno il contorno
		[ theDrawPath stroke ];
	}
	// se il rettangolo e' pieno
	if ( cceIsFilled )
	{
		// imposto il colore del pieno
		[ cceFillColor set ];
		// riempi tutto
		[ theDrawPath fill ];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// stringa che descrive l'elemento
- (NSString*)
describeMe
{
	return ( [ NSString stringWithFormat:@"Rect Elem ID %d", [ self objID] ] );
}

@end
