// -----------------------------------------------------------------------------
//  CCE_Text.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// interfaccia della classe per il disegno di testo

#import		<Foundation/Foundation.h>

#import		"CCE_Rect.h"

#define		CATAUTOTEXT_NULL			0
#define		CATAUTOTEXT_FILELIST		50
#define		CATAUTOTEXT_VOLNAME			51
#define		CATAUTOTEXT_MODDATE			53
#define		CATAUTOTEXT_CREATDATE		52
#define		CATAUTOTEXT_VOLSIZE			54
#define		CATAUTOTEXT_VOLFREESIZE		55

@interface CCE_Text : CCE_Rect
{
	// la classe che contiene il testo
	NSTextStorage   *textStorage;
	// flag che indica se il testo e' in corso di editing
	BOOL			editingText ;
	// flag che indica presenza di testo automatico
	int				automaticText ;
	// numero di colonne 
	int				numOfColumns ;
}

// i soliti metodi comuni
- (id)		initWithId: (int) ix inView: (CoverView*) cv 
				withAttributedString: (NSMutableAttributedString *) tt
				inRect: (NSRect) aRect withAngle: (float) angle ;
- (id )		init ;
- (void)	dealloc ;
- (void)	specificDrawing: (NSRect) inRect ;
- (void)	changeFont:(id)sender ;
- (void)	prepareTextStorage: (NSTextStorage *) ts ;
- (void)	adjustTextColumn ;

// accessor
- (NSTextStorage *)textStorage;
- (void)setTextStorage:(NSTextStorage *)newTextStorage;
- (BOOL)editingText;
- (void)setEditingText:(BOOL)newEditingText;
- (int)automaticText;
- (void)setAutomaticText:(int)newAutomaticText;
- (int)numOfColumns;
- (void)setNumOfColumns:(int)newNumOfColumns;

@end
