// -----------------------------------------------------------------------------
//  CatDataSrc.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// Interfaccia della classe sorgente dati

#import 	<Foundation/Foundation.h>

#import		"FileStruct.h"
#import		"FilterWinCtl.h"

@class		CdCatDoc ;
@class		CoverWinCtl ;

// per distinguere tra le varie tabelle uso diversi tag
#define		TAG_CDCATDOC_FILELIST		501
#define		TAG_CDCATDOC_FULLLIST		502

// funzione che determina se una directory e' un bundle
BOOL		checkIfBundleDirectory( NSString * fileName );

@interface CatDataSrc : NSObject
{
	// elenco dei volumi
	NSMutableArray	* startPoint ;
	// criterio di ordine
	NSString		* orderColumn ;
	// direzione dell'ordinamento
	BOOL			orderDirection ;
	// il documento cui fa riferimento
	CdCatDoc		* refDoc ;
	// volume correntemente selezionato
	int				currentVol ;
}

// inizializzazione e disallocazione
- (id)		init ;
- (void)	dealloc ;
// metodo per inserire un file al catalogo
- (void)	addFileEntry: (id) newEntry ;
- (void)	removeEntry: (FileStruct *) newEntry ;

// per la visualizzazione della lista dei volumi
- (int)		numberOfRowsInTableView:(NSTableView *)tv;
- (id)		tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tc row:(int)row;
- (BOOL)	tableView:(NSTableView *)tv shouldEditTableColumn:(NSTableColumn *)tc row:(int)row ;
// metodi delegati
- (void)	tableViewSelectionDidChange:(NSNotification *)aNotification ;
- (void)	setCACFileListFor: (NSTextStorage *) txtSto ;
- (void)	setCACAttribFor: (NSTextStorage *) txtSto ofName: (NSString*) colId ;

// per la visualizzazione della lista dei file
- (int)		outlineView: (NSOutlineView *) outlineView numberOfChildrenOfItem: (id) item;
- (BOOL)	outlineView: (NSOutlineView *) outlineView isItemExpandable: (id) item ;
- (id)		outlineView: (NSOutlineView *) outlineView child: (int) index ofItem: (id) item ;
- (id)		outlineView: (NSOutlineView *) outlineView objectValueForTableColumn: (NSTableColumn *) tableColumn byItem: (id) item;
- (void)	outlineView: (NSOutlineView *) outlineView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn byItem:(id)item ;
// metodi delegati
- (BOOL)	outlineView: (NSOutlineView *) oView shouldSelectTableColumn:(NSTableColumn *)tableColumn;
- (BOOL)	outlineView: (NSOutlineView *) oView shouldEditTableColumn: (NSTableColumn *) tableColumn item: (id) item ;
- (void)	outlineView: (NSOutlineView *) oView willDisplayCell:(id)aCell forTableColumn:(NSTableColumn *)aTableColumn item:(id)item ;
- (void)	outlineViewSelectionDidChange:(NSNotification *)notification ;

// ricerca e visualizzazione degli elementi trovati
- (void)	critSelect: (FltElemPtr) fltCrit withLogic: (int) logic oper: (int) operaz placeIn: (NSMutableArray *) where ;
- (void)	expandDStoItem: (FileStruct*) item inDocument: (CdCatDoc *) currDoc ;

// accessor
- (NSMutableArray *)startPoint;
- (void)setStartPoint:(NSMutableArray *)newStartPoint;
- (NSString *)orderColumn;
- (void)setOrderColumn:(NSString *)newOrderColumn;
- (BOOL)orderDirection;
- (void)setOrderDirection:(BOOL)newOrderDirection;
- (CdCatDoc *)refDoc;
- (void)setRefDoc:(CdCatDoc *)newRefDoc;

@end
