// -----------------------------------------------------------------------------
//  CdCatDoc.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// interfaccia della classe del documento del catalogo

#import 	<Cocoa/Cocoa.h>

#import 	"CatDataSrc.h"
#import 	"VolInfo.h"
#import 	"CoverWinCtl.h"
#import 	"ListWinCtl.h"

@interface 	CdCatDoc : NSDocument
{
	// dati presenti nel file
	NSData		* dataFromFile ;
	// la 'sorgente dei dati'
	CatDataSrc  * dataSource ;
	// le due finestre associate al documento
	ListWinCtl		* listWin  ;
	CoverWinCtl		* coverWin ;
}

- (id)		init ;
- (void)	dealloc ;
- (void) 	makeWindowControllers ;
- (void)	windowControllerDidLoadNib:(NSWindowController *) aController ;
- (NSData*)	dataRepresentationOfType: (NSString *)aType	;
- (BOOL)	loadDataRepresentation: (NSData *)data ofType: (NSString *)aType ;
- (void)	loadCatalogWithData: (NSData *) data ;
// gestione del catalogo
- (void)	addVolume2Cat: (NSWindow *)sheet returnCode: (int)returnCode contextInfo: (void *)contextInfo ;
- (void)	performAddFilesModal: ( NSArray *)volList  ;
// finestre accessorie
- (void)	refreshWinsWithListSts: (NSString*) sts1Bar coverSts: (NSString*) sts2Bar ;
- (void)	showCoversWindow ;

// accessor
- (CatDataSrc*)dataSource;
- (void)setDataSource:(CatDataSrc*)newDataSource;
- (NSData *)dataFromFile;
- (void)setDataFromFile:(NSData *)newDataFromFile;
- (CoverWinCtl *)coverWin ;
- (void)setCoverWin:(CoverWinCtl *)newCoverWin;

@end
