// -----------------------------------------------------------------------------
//  CoverPalWinCtl.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// realizzazione della palette per la finestra copertine

#import "CoverPalWinCtl.h"
#import "CCE_ElemGroup.h"

@implementation CoverPalWinCtl

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+ ( id )
sharedCoverPalWinCtrl
{
	static	CoverPalWinCtl	* locWinCtrl  = nil ;

	if ( ! locWinCtrl )
	{
		locWinCtrl = [[ CoverPalWinCtl allocWithZone: [self zone]] init ] ;
	}
	return ( locWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// inizializzo la finestra caricandola dal file nib
- (id )
init
{
	self = [ self initWithWindowNibName: @"coverPalette" ];
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// preparo la finestra la suo lavoro
- (void)
windowDidLoad
{
	currCCE = nil ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// imposta il tool selezionato
- (IBAction)
handleToolSel:(id)sender
{
	switch ( [ [toolMatrix selectedCell] tag ] ) {
	case 0 : currCCE = nil ; break ;
	case 1 : currCCE = [ CCE_Image class ] ; break ;
	case 2 : currCCE = [ CCE_Line class ] ; break ;
	case 3 : currCCE = [ CCE_Rect class ] ; break ;
	case 4 : currCCE = [ CCE_Circle class ]; break ;
	case 5 : currCCE = [ CCE_Text class ] ; break ;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// reset del tool alla freccia di selezione
- (void)
resetTool
{
	[toolMatrix selectCellWithTag: 0] ;
	 currCCE = nil ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// metodi per accedere alle impostazioni della palette
- (NSColor*)
getCurrLineColor
{
	return ( [ currLineWell color] );
}

- (NSColor*)
getCurrFillColor
{
	return ( [ currFillWell color] );
}

- (Class)
getCurrClassTool
{
	return ( currCCE );
}

- (BOOL)
getStrokeSts
{
	return ( [ lineCheckbox state] == NSOnState );
}

- (BOOL)
getFillSts
{
	return ( [ fillCheckbox state] == NSOnState );
}

- (float)
getLineWidth
{
	switch (  [[ lineWidth selectedItem] tag ] ) {
	case 0 : return ( 0.0F ) ;
	case 1 : return ( 1.0F ) ;
	case 2 : return ( 3.0F ) ;
	case 3 : return (10.0F ) ;
	default : return ( 0.0F );
	}
}

@end
