// -----------------------------------------------------------------------------
//  CoverWinCtl.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// realizzazione del controllore finestra della copertina

#import		"CoverWinCtl.h"

#import		"ChooseVolCtrl.h"
#import		"ImageAndTextCell.h"
#import		"CatFileInfo.h"
#import		"UserPrefs.h"
#import		"CatDataSrc.h" ;
#import		"CoverView.h" ;
#import		"CdCatDoc.h" ;
#import		"UnitsSizeGridWinCtl.h"
#import		"InfoWinCtrl.h"
#import		"CoverPalWinCtl.h"

#include	<math.h>

NSString* displayZoomFactor( float zf ) ;

@implementation CoverWinCtl

// ---------------------------------------------------------------------
- (void)
clicBtn01: (id)sender
{
	[ [ cvrView theElements] printMeWithLevel: 0 ];
}

// carico come come template
- (void)
clicBtn02: (id)sender
{
	NSString	* path = @"/Users/djzero00/Temporaneo/lista.plist"; 
	NSData		* xmlData;
	NSString	* error;
	
	xmlData = [NSPropertyListSerialization 
			dataFromPropertyList:[[ cvrView theElements] getXMLDescription ]
			format:NSPropertyListXMLFormat_v1_0
			errorDescription:&error];
	if(xmlData)
	{
		NSLog(@"No error creating XML data.");
		[xmlData writeToFile:path atomically:YES];
	}
	else
	{
		NSLog(error);
		[error release];
	}
}

// salvataggio come template
- (void)
clicBtn03: (id)sender
{
	NSString	* path = @"/Users/djzero00/Temporaneo/lista.plist"; 
	NSData		* plistData;
	NSString	* error;
	NSPropertyListFormat format;
	id			plist;
	CCE_ElemGroup	* listaElem ;

	plistData = [NSData dataWithContentsOfFile:path];
	plist = [NSPropertyListSerialization propertyListFromData:plistData
		mutabilityOption:NSPropertyListImmutable
		format:&format
		errorDescription:&error];
	if(!plist)
	{
		NSLog(error);
		[error release];
		return ;
	}
	listaElem = [ CCE_BasicForm buildElemFromXMLDesc: plist ];
	[ cvrView setTheElements: listaElem ];
	[ [ cvrView theElements] setOwnerView: cvrView ] ;
	[ cvrView setNeedsDisplay: YES ];
}

// ---------------------------------------------------------------------
// gestione dello slider di zoom
- (void)
setMaxSlider: (id)sender
{
	[ zoomSlider setFloatValue: [ zoomSlider maxValue]];
	[ self updateZoom: sender];
}

- (void)
setMinslider: (id)sender
{
	[ zoomSlider setFloatValue: [ zoomSlider minValue]];
	[ self updateZoom: sender];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
updateZoom: (id)sender
{
	float		czl, rl ;
	czl = [ zoomSlider floatValue ] ;
	// calcolo del fattore di zoom
	if ( czl >= 0 )
			rl = czl + 1;
	else	rl = 1 / (-czl+1) ;
	// impostazione dello zoom
	[ cvrView setZoom: rl ];
	[ zoomValue setStringValue: displayZoomFactor(rl) ];
	// ridisegno
	[ cvrView setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
arrangeZoom: (float) czl 
{
	float		rl ;
	[ zoomSlider setFloatValue: czl ] ;
	// calcolo del fattore di zoom
	if ( czl >= 0 )
			rl = czl + 1;
	else	rl = 1 / (-czl+1) ;
	// impostazione dello zoom
	[ cvrView setZoom: rl ];
	[ zoomValue setStringValue: displayZoomFactor(rl) ];
}

// ---------------------------------------------------------------------
// predisposizione del contenuto della finestra
- (void)
windowDidLoad
{
	NSTableColumn		* tableColumn1 = nil;
	ImageAndTextCell	* imageAndTextCell1 = nil;
	CatDataSrc			* myDataSrc ;
	NSArray				* lt ;
	int					i ;
	NSString			* tmpl ;

	[super windowDidLoad ];
	// associo questa finestra alla sorgente dati
	myDataSrc = [ [self document] dataSource] ;
	[ volList setDelegate:   myDataSrc ];
	[ volList setDataSource: myDataSrc ];
	// salvo nelle prefs le dimensioni delle colonne della outlineView
	[ volList setAutosaveName: @"VolumeViewOptions" ];
	tableColumn1 = [volList tableColumnWithIdentifier: @"volumeList"];
	// creo l'oggetto autorelease perche' passa in carico alla tableColumn
	imageAndTextCell1 = [[[ImageAndTextCell alloc] init] autorelease];
	[imageAndTextCell1 setEditable: NO];
	[tableColumn1 setDataCell:imageAndTextCell1];
	// metto a posto la dimensione della view della copertina
	[cvrView setFrameSize: [cvrView curViewSize] ];
	[ cvrView setWinCtl: self ];
	// predispongo le due view nascoste
	[ [ cvrView shScroll ] removeFromSuperview];
	[ cvrView addSubview: [ cvrView shScroll ]];
	[ [ cvrView shScroll ] setHasHorizontalScroller: NO ];
	[ [ cvrView shScroll ] setHasVerticalScroller: YES ];
	[ [ [ cvrView shScroll ] verticalScroller ] setControlSize: NSSmallControlSize ] ;
	[ [ cvrView shScroll ] setAutohidesScrollers: NO ];
	[ [ cvrView shScroll ] setBorderType: NSGrooveBorder ] ;
	// aggiorno, se necessario, il contenuto
	[ [[cvrView theElements] elemArray] makeObjectsPerformSelector: 
			@selector(updAutoText:) withObject: myDataSrc ] ;
	// metto a posto lo zoom
	[ zoomValue setStringValue: displayZoomFactor(1.0F) ];
	[[self window] makeFirstResponder:cvrView];
	// cerco tutti i file template
	lt = [ [NSBundle mainBundle] pathsForResourcesOfType:@"cdt" inDirectory: @"/" ];
	// e li inserisco nel popup button
	for ( i = 0 ; i < [ lt count ] ; i++ )
	{
		// metto solo il nome, senza extension
		tmpl = [ [ lt objectAtIndex: i ] lastPathComponent ];
		[ tmplList addItemWithTitle: [ tmpl stringByDeletingPathExtension ] ];
		// aggiusto il meccanismo target/Action
		[ [ tmplList itemAtIndex: ( 5 + i) ] setTarget: self ] ;
		[ [ tmplList itemAtIndex: ( 5 + i) ] setAction: @selector(loadTemplateFromFile:) ] ;
	}
	// alla partenza, nulla e' selezionato nel pop up menu
	[ tmplList selectItem: nil ] ;
}

// ---------------------------------------------------------------------
// carico come come template
- (IBAction)
templateSave: (id)sender
{
	NSSavePanel	*sPanel = [ NSSavePanel savePanel ] ;
	// personalizzo il pannello di salvataggio
	[ sPanel setTitle:@"Save template" ];
	// i file salvati avranno l'estensione lscat
	[ sPanel setRequiredFileType: @"cdt" ];
	if ( [ sPanel runModal ] == NSOKButton )
	{
		// recupero il nome del file
		NSString *aFile = [ sPanel filename ] ;
		// archivio l'intera struttura dati
		[NSKeyedArchiver archiveRootObject: cvrView toFile: aFile ];
	}
	[ tmplList selectItem: nil ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// salvataggio come template
- (IBAction)
templateLoad: (id)sender
{
	NSOpenPanel		*oPanel = [ NSOpenPanel openPanel ] ;
	int		risposta ;
	// imposto un po' di caratteristiche del dialogo 
	[ oPanel setTitle:@"Load Template" ];
	[ oPanel setPrompt:@"Load Template" ];
	// niente directory, un solo file alla volta
	[ oPanel setCanChooseDirectories:NO ];
	[ oPanel setCanChooseFiles:YES ];
	[ oPanel setAllowsMultipleSelection:NO ];
	[ oPanel setResolvesAliases:YES ];
	// posso selezionare solo i file che hanno estensione cdt
	risposta = [ oPanel runModalForTypes: [ NSArray arrayWithObjects: @"cdt" ] ];
	// se c'e' una selezione effettiva...
	if ( risposta == NSOKButton )
	{
		// ... recupero il nome del file selezionato
		NSArray *filesToOpen = [ oPanel filenames ];
		NSString *aFile = [ filesToOpen objectAtIndex: 0 ];
		// ed uso il template per costruire la view
		[ cvrView loadFromTemplate: aFile ]; 
	}
	[ tmplList selectItem: nil ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// risposta ai menu popup dei template standard
- (IBAction) 
loadTemplateFromFile: (id)sender
{
	NSString	* selTmpl ;
	NSString	* itTit ;
	// recupero il nome del template
	itTit = [ sender title ] ;
	// recupero il percorso completo del template
	selTmpl = [ [NSBundle mainBundle] pathForResource: itTit ofType:@"cdt" ];
	// carico il template
	[ cvrView loadFromTemplate: selTmpl ];
}

// ---------------------------------------------------------------------
// il titolo della finestra e' particolarizzato
- (NSString *)
windowTitleForDocumentDisplayName:(NSString *)displayName
{
	return ( [ @"Cover List: " stringByAppendingString: displayName] );
}

// ---------------------------------------------------------------------
// metodi comuni a tutti i controllori di finestra del documento
// aggiornamento del contenuto della finestra
- (void)
refreshWindow
{
	[ volList reloadData ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// impostazione della barra di stato
- (void)
setStsStrings: (NSString *) sts1Val
	andSts: (NSString *) st2Val;
{
	// per ora faccio nulla
	return ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// delegato per la chiusura delal finestra
- (BOOL)
windowShouldClose:(id)sender
{
	[ [ self document ] setCoverWin: nil ] ;
	// la finestrasi puo' sempre chiudere
	return ( YES );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// come responder principale accetto il cambio di font
- (void)
changeFont:(id)sender
{
	[ [ cvrView theElements ] changeFont: sender ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
showUSGDiag: (id)sender
{
	// mostro la finestra invocando l'istanza condivisa
	[ [ UnitsSizeGridWinCtl sharedGridDialogWinCtl ] showWindow: sender ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
showCoverPalette:(id)sender
{
	// mostro la finestra invocando l'istanza condivisa
	[ [ CoverPalWinCtl sharedCoverPalWinCtrl ] showWindow: sender ] ;
}

// ---------------------------------------------------------------------
// accessor
- (CoverView *)cvrView {
	return cvrView ;
}

- (void)setCvrView:(CoverView *)newCvrView {
	if (cvrView != newCvrView) {
		[cvrView release];
		cvrView = [newCvrView retain];
	}
}

@end

// ---------------------------------------------------------------------
// preparo la stringa dello zoom factor
NSString*
displayZoomFactor( float zf )
{
	if ( zf < 1 )
	{
		return ( [NSString stringWithFormat: @"x1/%2.1f", (1/zf) ] );
	}
	return ([NSString stringWithFormat: @"x%2.1f", zf ] );
}
