// -----------------------------------------------------------------------------
//  ElemParamWinCtl.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// finestra dei parametri di un elemento grafico

#import <Cocoa/Cocoa.h>

@class		CoverView;
@class		CCE_BasicForm;

// identificatori dei pannelli
#define		SECTSEL_INFO			@"info"
#define		SECTSEL_ALIGNROTATE		@"alignRotate"
#define		SECTSEL_SPECIAL			@"special"

@interface ElemParamWinCtl : NSWindowController
{
	// puntatore di comodo all'elemento sleezionato
	CCE_BasicForm			* theSelectedElem ;
	// la tabview
	IBOutlet NSTabView		* thetab ;
	// outlet ai vari elementi della finestra, pannello 1
	IBOutlet NSTextField	* curUnits ;
	IBOutlet NSTextField	* elemId;
	IBOutlet NSButton		* fillCheckbox;
	IBOutlet NSColorWell	* fillColorWell;
	IBOutlet NSButton		* lineCheckbox;
	IBOutlet NSColorWell	* lineColorWell;
	IBOutlet NSSlider		* lineWidthSlider;
	IBOutlet NSTextField	* lineWidthTextField;
	IBOutlet NSTextField	* xTextField;
	IBOutlet NSTextField	* yTextField;
	IBOutlet NSTextField	* widthTextField;
	IBOutlet NSTextField	* heightTextField;
	IBOutlet NSTextField	* rotationText;
	IBOutlet NSSlider		* rotationSlider;
	// matrice dei pulsanti della palette align
	IBOutlet NSMatrix		* selectedAlign;
	IBOutlet NSButton		* execBtn;
	// elementi della palette rotate
	IBOutlet NSSlider		* crcSlider;
	IBOutlet NSMatrix		* dirRadioBtn;
	IBOutlet NSSlider		* linSlider;
	IBOutlet NSTextField	* valField;
	// elementi della palette trasparenza immagini
    IBOutlet NSSlider		* transpSlider;
    IBOutlet NSTextField	* transpText;
    IBOutlet NSButton		* makeImgOriginalsize;
	// elementi della palette parametri del testo
	IBOutlet NSPopUpButton	* autoTxtMenu;
    IBOutlet NSTextField	* columnNum;
}

// cambiamento di un attributo
- (IBAction)changedElem:(id)sender;
// modifiche sul pannello 1
- (IBAction)slideChange:(id)sender	;
- (IBAction)rotationChange:(id)sender ;
// allineamento
- (IBAction)executeAlign:(id)sender;
// rotazione
- (IBAction)execRotation:(id)sender;
- (IBAction)updateSliders:(id)sender;
// parametri del testo
- (IBAction) setTextParams:(id)sender;
// trasparenza immagine
- (IBAction)setTransparency:(id)sender;
- (IBAction)setOriginalSize:(id)sender;

// inizializzazioni
+ (id)		sharedElemParamWinCtl;
- (id)		init ;
- (void)	windowDidLoad ;
// aggiornamento della finestra
- (void)	setControlsEnabled: (unsigned long) status ;
- (void)	updateWindowInfo ;
- (void)	setSelectedElem: (CCE_BasicForm *) selElem ;

- (void)	selectPanel: (NSString *) uot ;

@end
