/* FilterWinCtl */

#import <Cocoa/Cocoa.h>

//#import		"CdCatDoc.h"
@class	CdCatDoc ;

// ---------------------------------------------------------------------
typedef struct	_filterElem {
	int			fieldId ;
	int			operId ;
	id			theValue ;
}
	FltElemStruct, * FltElemPtr ;

// menu del campo di ricerca "where"
#define		MENUTAG_FILENAME		 0
#define		MENUTAG_MODDATE			 1
#define		MENUTAG_CREATDATE		 2
#define		MENUTAG_FILESIZE		 3
#define		MENUTAG_GROUPNAME		 4
#define		MENUTAG_OWNERNAME		 5
#define		MENUTAG_POSIXPERM		 6
#define		MENUTAG_OSCREATOR		 7
#define		MENUTAG_OSTYPE			 8

#define		MENUTAG_SPECIAL			 9

// menu delle opzioni di ricerca stringa
#define		MENUTAG_STR_ISCONTAINED		101
#define		MENUTAG_STR_ISEQUAL			102

// menu delle opzioni di ricerca numerica
#define		MENUTAG_NUM_EQ				201
#define		MENUTAG_NUM_DIFFERENT		202
#define		MENUTAG_NUM_GREAT			203
#define		MENUTAG_NUM_LESS			204

#define		MENUTAG_FOLDER				600
#define		MENUTAG_BUNDLE				601
#define		MENUTAG_SIMPLEFILE			602
#define		MENUTAG_ALLFILES			603
#define		MENUTAG_NONE				604

#define		FILTER_LOGIC_AND			300
#define		FILTER_LOGIC_OR				301

#define		FILTER_OPER_SEARCH			500
#define		FILTER_OPER_SETPRINT		501
#define		FILTER_OPER_ADDPRINT		502
#define		FILTER_OPER_REMPRINT		503


#define		TABLEVIEWTAG_CRITERI		111
#define		TABLEVIEWTAG_RISULTATI		112

// ---------------------------------------------------------------------

@interface FilterWinCtl : NSWindowController
{
    IBOutlet NSTableView	* listaCriteri ;
    IBOutlet NSPopUpButton	* logicPop;
    IBOutlet NSPopUpButton	* operPop;
    IBOutlet NSMenu			* operMenu;
    IBOutlet NSMenu			* compMenu;
    IBOutlet NSMenu			* strMenu;
    IBOutlet NSMenu			* typeMenu;
	IBOutlet NSTableView 	* resultFld;
	IBOutlet NSTextField 	* resultMsg;
	// variabili interne
	int						numOfCriteri ;
	FltElemStruct			criteriFiltro[10] ;
	// documento cui si riferisce la ricerca
	CdCatDoc				* currCatalog ;
	// vettore con i risultati
	NSMutableArray			* foundItems;
}
+ ( id )		sharedFilterWinCtl ;
// gestione sul numero dei criteri
- (IBAction)	addAnotherCrit:(id)sender;
- (IBAction)	removeCrit:(id)sender;
// gestione dei criteri
- (IBAction)	popUpSelectField:(id)sender;
- (IBAction)	popUpSelectOper:(id)sender;
- (IBAction)	clearAll:(id)sender;
// esecuzione delel operazioni di ricerca/filtraggio
- (IBAction)	filterElem:(id)sender;

// per evidenziare l'elemento selezionato
- (IBAction)goToItem: (id)sender;
// gestione delle tabelle
- (int)		numberOfRowsInTableView:(NSTableView *)tv;
- (id) 		tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tc row:(int)row;
- (BOOL)	tableView:(NSTableView *)tv shouldEditTableColumn:(NSTableColumn *)tc row:(int)row ;
// accessor
- (CdCatDoc *)currCatalog ;
- (void)setCurrCatalog :(CdCatDoc *)newCurrCatalog ;
- (NSMutableArray *)foundItems;
- (void)setFoundItems:(NSMutableArray *)newFoundItems;

@end
