#import		"FilterWinCtl.h"

#import		"CatFileInfo.h"

#import 	"LocalFormatters.h"
#import		"CdCatDoc.h"

void	convert2string( FltElemPtr critPtr ) ;
void	convert2date( FltElemPtr critPtr ) ;
void	convert2number( FltElemPtr critPtr ) ;

@implementation FilterWinCtl

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// gestione dell'istanza condivisa
+ ( id )
sharedFilterWinCtl
{
	static	FilterWinCtl	* locWinCtrl  = nil ;

	if ( ! locWinCtrl )
	{
		locWinCtrl = [[ FilterWinCtl allocWithZone: [self zone]] init ] ;
	}
	return ( locWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// inizializzazione del vettore dei criteri
- (void) 
resetCriteriFiltro
{
	numOfCriteri = 1 ;
	criteriFiltro[0].fieldId = MENUTAG_FILENAME ;
	criteriFiltro[0].operId = MENUTAG_STR_ISEQUAL ;
	criteriFiltro[0].theValue = [ NSString stringWithString:  @"che ne so" ] ;
	[ criteriFiltro[0].theValue retain ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// inizializzazione della classe
- (id )
init
{
	self = [ self initWithWindowNibName: @"FilterWin" ];
	[ self resetCriteriFiltro ];
	[self setFoundItems: [ NSMutableArray array ]];
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// dealloc della classe
- (void)
dealloc
{
	[ foundItems release ] ;
	[ super dealloc ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// caricamento della finestra
- (void)
windowDidLoad
{
	// un doppio clic su di una riga mostra l'elemento selezionato
	// (risultato di una ricerca) all'interno del documento che lo contiene
	[ resultFld setDoubleAction: @selector( goToItem:) ];
	[ resultMsg setStringValue: @"" ];
	if ( numOfCriteri <= 1 )
		[ logicPop setEnabled: NO ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// reset dei criteri di ricerca
- (IBAction)
clearAll:(id)sender
{
	[ self resetCriteriFiltro ];
	[ listaCriteri reloadData ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// esecuzione delle operazioni di filtraggio
- (IBAction)
filterElem:(id)sender
{
	int		i ;
	// recupero il catalogo dove effettuare la ricerca
	// piglio tutti i documenti dell'applicazione, e scelgo quello che sta
	// davanti a tutti gli altri... non che questo meccanismo mi piaccia...
	[ self setCurrCatalog: (CdCatDoc*)[[ NSApp orderedDocuments] objectAtIndex: 0] ];
	// pulisco i risultati della ricerca precedente
	[ self setFoundItems: [ NSMutableArray array ]];
	// e li tolgo dalla finestra di ricerca
	[ resultFld reloadData ];
	[ resultMsg setStringValue: [ NSString 
		stringWithFormat: @"Found %d elements", [ foundItems count] ]];
	// ripulisco criteriFiltro mettendo una guardia a fine vettore
	for ( i = numOfCriteri ; i < 10 ; i++ )
		criteriFiltro[i].fieldId = -1 ;
	[ [ [ self currCatalog ] dataSource ] critSelect: criteriFiltro 
				withLogic:  [ [ logicPop selectedItem ] tag ]
				oper:		[ [ operPop selectedItem ] tag ] 
				placeIn:	foundItems];
		// forzo il rinfresco della finestra dei risultati
	[ resultFld reloadData ];
	[ resultMsg setStringValue: [ NSString 
		stringWithFormat: @"Found %d elements", [ foundItems count] ] ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// aggiunta di un criterio
- (IBAction)
addAnotherCrit:(id)sender
{
	if ( numOfCriteri >= 10 ) return ;
	criteriFiltro[numOfCriteri].fieldId = MENUTAG_FILENAME ;
	criteriFiltro[numOfCriteri].operId = MENUTAG_STR_ISCONTAINED ;
	criteriFiltro[numOfCriteri].theValue = 
		[ NSString stringWithString:  @"che ne so" ] ;
	[ criteriFiltro[numOfCriteri].theValue retain ] ;
	numOfCriteri += 1 ;
	[ logicPop setEnabled: YES ] ;
	[ listaCriteri reloadData ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// rimozione di un criterio
- (IBAction)
removeCrit:(id)sender
{
	int		row = [listaCriteri selectedRow ] ;
	int		i ;
	
	if ( numOfCriteri <= 1 ) return ;
	for ( i = row ; i < numOfCriteri-1 ; i ++ )
	{
		criteriFiltro[i].fieldId = criteriFiltro[i+1].fieldId ;
		criteriFiltro[i].operId = criteriFiltro[i+1].operId ;
		if (criteriFiltro[i].theValue != criteriFiltro[i+1].theValue) 
		{
			[ criteriFiltro[i].theValue release ];
			criteriFiltro[i].theValue = 
				[ criteriFiltro[i+1].theValue copy ];
			[ criteriFiltro[i].theValue retain ];
		}
	}
	[ criteriFiltro[numOfCriteri-1].theValue release ];
	numOfCriteri -=1 ;
	if ( numOfCriteri <= 1 )
		[ logicPop setEnabled: NO ] ;
	[ listaCriteri reloadData ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// gestione dei meu pop up: selezione menu del campo
- (IBAction)
popUpSelectField:(id)sender
{
	int		row = [listaCriteri selectedRow ] ;
	int		whois = [ sender tag ] ;
	
	if ( row >= numOfCriteri ) return ;
	switch ( whois ) {
	case MENUTAG_FILENAME:
	case MENUTAG_GROUPNAME:		
	case MENUTAG_OWNERNAME:
		criteriFiltro[row].fieldId = whois ;
		criteriFiltro[row].operId = MENUTAG_STR_ISCONTAINED ;
		// devo convertire il valore in una stringa
		convert2string( & criteriFiltro[row] ) ;
		break ;
	case MENUTAG_MODDATE: 		
	case MENUTAG_CREATDATE : 
		criteriFiltro[row].fieldId = whois ;
		criteriFiltro[row].operId = MENUTAG_NUM_EQ ;
		// devo convertire il valore in una data
		convert2date( & criteriFiltro[row] ) ;
		break ;
	case MENUTAG_POSIXPERM: 	
	case MENUTAG_OSCREATOR:
	case MENUTAG_OSTYPE:		
	case MENUTAG_FILESIZE :
		criteriFiltro[row].fieldId = whois ;
		criteriFiltro[row].operId = MENUTAG_NUM_EQ ;
		// devo convertire il valore in un numero
		convert2number( & criteriFiltro[row] ) ;
		break ;
	case MENUTAG_SPECIAL :
		criteriFiltro[row].fieldId = whois ;
		criteriFiltro[row].operId = MENUTAG_NONE ;
		break ;	
	// non dovrebbe mai succedere ...
	default : 
		criteriFiltro[row].fieldId = MENUTAG_FILENAME ;
		criteriFiltro[row].operId = MENUTAG_STR_ISCONTAINED ;
		break ;	
	}
	[ listaCriteri reloadData ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// selezione del menu operazioni
- (IBAction)
popUpSelectOper:(id)sender
{
	int		row = [listaCriteri selectedRow ] ;
	int		whois = [ sender tag ] ;
	
	if ( row >= numOfCriteri ) return ;
	criteriFiltro[row].operId = whois ;
	[ listaCriteri reloadData ] ;
}

// ---------------------------------------------------------------------
// metodi dataSource, per due diverse tableView
- (int)
numberOfRowsInTableView:	(NSTableView *)tableView
{
	if ( [ tableView tag ] == TABLEVIEWTAG_CRITERI )
			return (numOfCriteri);
	else	return [foundItems count];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// metodi dataSource, per due diverse tableView
- (id)
tableView:			(NSTableView *)tableView
	objectValueForTableColumn:	(NSTableColumn *)tableColumn
	row: 			(int)row
{
	if ( [ tableView tag ] == TABLEVIEWTAG_CRITERI )
	{
		// sono nella tabella criteri
		NSString * colId = [ tableColumn identifier] ;
		// l'unico valore sensato da restituire sta qui
		if ( [ colId isEqual: @"valueSpec" ] )
		{
			// se il campo specificato e' speciale
			if ( criteriFiltro[row].fieldId == MENUTAG_SPECIAL )
				return ( @"   " );
			// altrimenti, restiuisco il valore nudo
			return ( criteriFiltro[row].theValue );
		}
		// giusto per ritornare qualcosa sempre
		return ( @"dummy" );
	}
	else
	{
		// sono nella tabella risultati
		CatFileInfo	* item = [foundItems objectAtIndex: row] ;
		NSString	* colId = [ tableColumn identifier] ;
		// ho al momento due colonne: il nome o l'intero percorso
		if ( [ colId isEqual: COLID_FILENAME ] )
			return ( [ item fileName] );
		return ( [ item fileFullPath] );
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// per aggiustare i pop up sulla prima tableView
- (void)
tableView:(NSTableView *)aTableView 
	willDisplayCell:(id)aCell 
	forTableColumn:(NSTableColumn *)aTableColumn 
	row:(int)rowIndex
{
	if ( [ aTableView tag ] == TABLEVIEWTAG_CRITERI )
	{
		// sono nella tabella criteri
		NSString * colId = [ aTableColumn identifier] ;
		// menu pop up della scelta campo
		if ( [ colId isEqual: @"fieldSpec" ] )
		{
			// ricavo quale item e' da evidnziare
			int	qualemenu = (criteriFiltro[rowIndex].fieldId - MENUTAG_FILENAME) ;
			[ aCell selectItemAtIndex: qualemenu ] ;
		}
		// menu pop up delle operazione di confronto
		if ( [ colId isEqual: @"operSpec" ] )
		{
			// tag del menu da visualizzare
			// per avere l'indice, dovro' sottrarre il tag base
			int	newCode = criteriFiltro[rowIndex].operId ;
			// imposto menu e item selezionato in dipendenza
			// dalla scelta del campo
			switch ( criteriFiltro[rowIndex].fieldId ) {
			case MENUTAG_FILENAME:		// stringhe
			case MENUTAG_GROUPNAME:		// cfr: uguale
			case MENUTAG_OWNERNAME:		//	contenuto
				[ aCell setMenu: strMenu ] ;
				newCode -= MENUTAG_STR_ISCONTAINED ;
				break ;
			case MENUTAG_MODDATE: 		// cfr: eguale, diverso
			case MENUTAG_CREATDATE:		//	maggiore, minore
			case MENUTAG_FILESIZE:
				[ aCell setMenu: operMenu ] ;
				newCode -= MENUTAG_NUM_EQ ;
				break ;
			case MENUTAG_OSTYPE: 		// cfr: uguale
			case MENUTAG_POSIXPERM: 	//	diverso
			case MENUTAG_OSCREATOR:
				[ aCell setMenu: compMenu ] ;
				newCode -= MENUTAG_NUM_EQ ;
				break ;
			case MENUTAG_SPECIAL :		// crf, nessuno
				[ aCell setMenu: typeMenu ] ;
				newCode -= MENUTAG_FOLDER ;
				break ;
			}
			[ aCell selectItemAtIndex: newCode ] ;
		}
		// aggiusto un formatter per visualizzare il dato
		// nella forma piu' acconcia
		if ( [ colId isEqual: @"valueSpec" ] )
		{
			TOS9TCForm		*myDF1 ;
			FileSizeForm 	*myDF2 ;
			FilePosixPerm 	*myDF3 ;
			NSDateFormatter *myDF4 ;
			
			switch ( criteriFiltro[rowIndex].fieldId ) {
			case MENUTAG_FILENAME:		// stringhe
			case MENUTAG_SPECIAL :
			case MENUTAG_GROUPNAME:		
			case MENUTAG_OWNERNAME:
				[ aCell setFormatter:  nil ];
				break ;
			case MENUTAG_OSTYPE: 		// os type
			case MENUTAG_OSCREATOR:
				myDF1 = [[[ TOS9TCForm alloc ] init ] autorelease ];
				[ aCell setFormatter:  myDF1 ];
				break ;
			case MENUTAG_FILESIZE:		// dim file
				myDF2 = [[[ FileSizeForm alloc ] init ] autorelease ];
				[ aCell setFormatter:  myDF2 ];
				break ;
			case MENUTAG_POSIXPERM:		// posix perm
				myDF3 = [[[ FilePosixPerm alloc ] init ] autorelease ];
				[ aCell setFormatter:  myDF3 ];
				break ;
			case MENUTAG_MODDATE: 		// date
			case MENUTAG_CREATDATE:
				myDF4 = [ [NSDateFormatter alloc]
					initWithDateFormat: @"%d %b %Y" 
					allowNaturalLanguage: YES];
				[ aCell setFormatter:  myDF4 ];
				break ;
			}
		}
	}
	// niente da fare per la tabella risultati
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// la prima tableView e' editabile, la seconda no
- (BOOL)
tableView: (NSTableView *)aTableView
	shouldEditTableColumn:	(NSTableColumn *)aTableColumn
	row: (int)rowIndex
{
	if ( [ aTableView tag ] == TABLEVIEWTAG_CRITERI )
	{
		NSString * colId = [ aTableColumn identifier] ;
		if ( [ colId isEqual: @"valueSpec" ] )
		{
			if ( criteriFiltro[rowIndex].fieldId == MENUTAG_SPECIAL )
					return NO ;
		}
		return YES ;
	}
	else return NO ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// assegnazione dei valori sulla prima tableView
- (void)
tableView:(NSTableView *)aTableView 
	setObjectValue:(id)anObject 
	forTableColumn:(NSTableColumn *)aTableColumn 
	row:(int)rowIndex
{
	if ( [ aTableView tag ] == TABLEVIEWTAG_CRITERI )
	{
		NSString * colId = [ aTableColumn identifier] ;
		if ( [ colId isEqual: @"valueSpec" ] )
		{
			[ criteriFiltro[rowIndex].theValue release ] ;
			criteriFiltro[rowIndex].theValue = anObject  ;
			[ criteriFiltro[rowIndex].theValue retain ] ;
		}
	}
}

// ---------------------------------------------------------------------
// metodo chiamato da un doppio clic sulla tabella con i risultati della ricerca
- (IBAction)
goToItem:(id)sender
{
	FileStruct	* item ;
	// verifico che ci sia una riga selezionata
	if ( [ sender selectedRow ] == -1 ) return ;
	// recupero l'elemento selezionato
	item = [ foundItems objectAtIndex: [ sender selectedRow ]];
	// controllo che il documento cui si riferisce la ricerca sia ancora presente
	if ( ! [ [ NSApp orderedDocuments] containsObject: [self currCatalog] ] )
	{
		// il documento non c'e' piu', informo l'utente con un alert
		NSBeginAlertSheet(@"Missing Catalog", @"Ok, ok", nil, nil,
			[self window], nil, nil, nil, nil,
			@"The Catalog Document is no longer present") ;
		// non ho altro da fare...
		return ;
	}
	// qui abbiamo il catalogo, ed abbiamo l'item; lo cerchiamo e lo apriamo
	[[ [self currCatalog] dataSource ] expandDStoItem: item
		inDocument: [self currCatalog] ];
	// forzo il redisplay della finestra del catalogo
	[ [self currCatalog] refreshWinsWithListSts: @"" coverSts: @"" ];
	// metto la finestra del catalogo davanti alle altre
	[ [self currCatalog] showWindows ] ;
}

// ---------------------------------------------------------------------
// accessor

- (CdCatDoc *)currCatalog {
	return currCatalog ;
}

- (void)setCurrCatalog:(CdCatDoc *)newCurrCatalog {
	if (currCatalog != newCurrCatalog) {
		[currCatalog release];
		currCatalog = [newCurrCatalog retain];
	}
}

- (NSMutableArray *)foundItems {
	return foundItems ;
}

- (void)setFoundItems:(NSMutableArray *)newFoundItems {
	if (foundItems != newFoundItems) {
		[foundItems release];
		foundItems = [newFoundItems retain];
	}
}

@end

// ---------------------------------------------------------------------
// funzioni per convertire un dato oggetto in altro formato
void
convert2string( FltElemPtr critPtr )
{
	if ( [ critPtr->theValue isKindOfClass:[NSDate class] ] )
	{
		NSString	* xx = [ critPtr->theValue description ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
	else if ( [ critPtr->theValue isKindOfClass:[NSNumber class] ] )
	{
		NSString	* xx = [ critPtr->theValue description ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void
convert2date( FltElemPtr critPtr )
{
	if ( [ critPtr->theValue isKindOfClass:[NSString class] ] )
	{
		NSDate	* xx = [ NSDate dateWithString: critPtr->theValue ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
	else if ( [ critPtr->theValue isKindOfClass:[NSNumber class] ] )
	{
		NSString	* xx = [ NSDate dateWithTimeIntervalSinceNow: 
				[ critPtr->theValue floatValue] ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void
convert2number( FltElemPtr critPtr )
{
	if ( [ critPtr->theValue isKindOfClass:[NSString class] ] )
	{
		NSNumber	* xx = [ NSNumber numberWithFloat: 
			[ critPtr->theValue floatValue ] ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
	else if ( [ critPtr->theValue isKindOfClass:[NSDate class] ] )
	{
		NSNumber	* xx = [ NSNumber numberWithDouble: 
			[ critPtr->theValue timeIntervalSince1970 ] ] ;
		[ critPtr->theValue release ];
		critPtr->theValue = [ xx copy ];
		[ critPtr->theValue retain ];
	}
}


