// -----------------------------------------------------------------------------
//  InfoWinCtrl.m
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// realizzazione della classe per la gestione delle info sul file

#import 	"InfoWinCtrl.h"

#import		"LocalFormatters.h"
#import 	"FileStruct.h"
#import 	"CdCatDoc.h"
#import 	"AppDelegate.h"

@implementation InfoWinCtrl
// ---------------------------------------------------------------------
// costruisto l'istanza condivisa
+ ( id )
sharedInfoWinCtrl
{
	static	InfoWinCtrl	* locWinCtrl  = nil ;

	if ( ! locWinCtrl )
	{
		locWinCtrl = [[ InfoWinCtrl allocWithZone: [self zone]] init ] ;
	}
	return ( locWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// inizializzo la finestra caricandola dal file nib
- (id )
init
{
	self = [ self initWithWindowNibName: @"infoPanel" ];
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// preparo la finestra la suo lavoro
- (void)
windowDidLoad
{
	// costruisco i formattatori che mi servono
	TOS9TCForm		*myDF1 = [[[ TOS9TCForm alloc   ] init ] autorelease ];
	FileSizeForm 	*myDF2 = [[[ FileSizeForm alloc ] init ] autorelease ];
	FilePosixPerm 	*myDF3 = [[[ FilePosixPerm alloc ] init ] autorelease ];
	[ super windowDidLoad ] ;
	// installo i formattatori
	[ osCreator setFormatter:  myDF1 ];
	[ osType	setFormatter:  myDF1 ];
	[ fileSize  setFormatter:  myDF2 ];
	[ posixPerm setFormatter:  myDF3 ];
	[ self updateInfo: [ AppDelegate getTheOutlineView] ];
}

// ---------------------------------------------------------------------
// aggiorno la finestra quando cambia la sezione o la finestra
- (void)
updateInfo: (NSOutlineView *) outView
{
	long		row = [ outView selectedRow] ;
	FileStruct	* locItem ;
	// vedo se ci sono selezioni in corso
	// non c'e' la outlineView, oppure nessuna selezione
	if ( (outView == nil) || (row == -1) )
	{
		// se non ce ne sono, faccio nulla
		// ripulisco la finestra
		[ groupName setStringValue: @""];
		[ ownerName setStringValue: @""];
		[ fullPath setStringValue: @""];
		[ fileSize setObjectValue: nil ];
		[ osCreator setObjectValue:  nil ] ;
		[ osType setObjectValue: nil ];
		[ posixPerm setObjectValue:  nil ];
		[ modDate setObjectValue: nil ];
		[ creatDate setObjectValue: nil ];
		[ fileIcon setObjectValue : nil ];
		[[ self window ] setTitle: @"No Info" ] ;
		return ;
	}
	// se arrivo qui, ho una outlineView ed un elemento selezionato
	// altrimenti, uso l'elemento selezionato
	locItem = [ outView itemAtRow: row ] ;
	// se l'oggetto e' reale, aggiorno il contenuto
	[ groupName setStringValue: [ locItem ownGroupName]];
	[ ownerName setStringValue: [ locItem ownerName]];
	[ fullPath  setStringValue: [ locItem fileFullPath]];
	// questi hanno un formattatore appiccicato, gli passo direttamente l'intero
	[ fileSize  setObjectValue: [NSNumber numberWithLongLong: [ locItem fileSize] ]];
	[ osCreator setIntValue:	[ locItem creatorCode]] ;
	[ osType	setIntValue:	[ locItem typeCode] ];
	[ posixPerm setIntValue:	[ locItem filePosixPerm] ];
	// qui, con il formattatore di data, gli passo direttamente l'oggetto NSDate
	[ modDate   setObjectValue: [ locItem modDate]];
	[ creatDate setObjectValue: [ locItem creatDate]];
	// recupero l'icona del file
	[ fileIcon  setObjectValue: [locItem fileIcon] ];
	// infine, il nome del file e' il titolo della finestra
	[[ self window ] setTitle: [ locItem fileName ]] ;
}

@end
