// -----------------------------------------------------------------------------
//  ListWinCtl.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// interfaccia della finestra con la lista dei file

#import 	<Cocoa/Cocoa.h>

@interface ListWinCtl : NSWindowController
{
	IBOutlet NSOutlineView *fullList;
	IBOutlet NSTextField *statusBar;
}

- (void)	windowDidLoad ;
- (NSString *)	windowTitleForDocumentDisplayName:(NSString *)displayName	;
// metodi per la gestione della toolbar
- (void)	addToolbarToWin: (NSWindow *) currWin ;
- (NSToolbarItem *) toolbar: (NSToolbar *)t itemForItemIdentifier: (NSString *) i willBeInsertedIntoToolbar:(BOOL) w ;
- (NSArray*) toolbarDefaultItemIdentifiers: (NSToolbar *) toolbar ;
- (NSArray*) toolbarAllowedItemIdentifiers: (NSToolbar *) toolbar ;
- (BOOL) 	validateToolbarItem: (NSToolbarItem *) toolbarItem ;
// aggiunta di un elemento al catalogo
- (void)	addFileItem: (id)sender ;
// rimozione di un elemento dal catalogo
- (void)	delItem: (id)sender ;
- (void)	prefsUpdated: ( NSNotification *) notification ;
// drag and drop
- (unsigned int)	draggingEntered:(id<NSDraggingInfo>)sender	;
- (unsigned int)	draggingUpdated:(id<NSDraggingInfo>)sender	;
- (void)	draggingExited:(id<NSDraggingInfo>)sender	;
- (BOOL)	prepareForDragOperation:(id<NSDraggingInfo>)sender	;
- (BOOL)	performDragOperation:(id<NSDraggingInfo>)sender	;
- (void)	concludeDragOperation:(id<NSDraggingInfo>)sender	;
// gestione finestra
- (BOOL)	shouldCloseDocument	;
- (void)	changeSortOrder: (id) sender 	;
- (void)	refreshWindow ;
- (void)	setStsStrings: (NSString *) sts1Val andSts: (NSString *) st2Val;
- (NSOutlineView *)	fullList ;

// finestre accessorie
- (void)	showInfoPanel:(id)sender;		// finestra informazioni file
- (void)	showCoversWindow:(id)sender ;	// finestra con la copertina
- (void)	showFindWin: (id)sender ;		// finestra ricerche

@end


