//
//  PrintView.m
//  CdCat2
//
//  Created by Livio Sandel on 04/09/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import		"PrintView.h"

#import		"CatFileInfo.h"
#import		"djZeroUtils.h"

#define		TEST_01		0
#define		TEST_02		0
#define		TEST_03		0

@implementation PrintView

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// inizializzazione dell'istanza
- (id)
initWithOutline:(NSOutlineView *) outView
{
	v2p = outView ;
	scaleFactor = 1 ;
	totPageNum = curPageNum = 0 ;
	// metto un frame a caso, sara' aggiustato poi
    self = [super initWithFrame: [ outView frame ] ];
    return self;
} 

#if		( ! (TEST_02))
// ---------------------------------------------------------------------
// i seguenti tre metodi sono da sovrascrivere per realizzare una 
// paginazione secondo la prorpia volonta'
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// chiamato per primo, vuole sapere quante pagine sono disponibili
- (BOOL)
knowsPageRange:(NSRangePointer)range 
{
	[ self prepareViewForPrinting: YES ] ;
    [ self calcPrintValues ] ;
    range->location = 1;
    range->length =  totPageNum ;
    return YES;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// chiamato prima del disegno di ogni pagina, restituisce la zona della
// pagina che sara' stampato
- (NSRect)
rectForPage:(int)page 
{
	NSRect	lr ;
	// offset corrente 
	float	dimpage = (page - 1) * altezzaPagina ;
	// righe ancora da stampare
	int		restoRighe = righeDaStampare - (page-1)* righePerPagina ;
	// la dimensioen della pagina e' per il momento quella standard
	curAltezzaPagina = altezzaPagina ;
	// se pero' ci sono poche righe rimaste...
	if ( restoRighe < righePerPagina )
			curAltezzaPagina = restoRighe * altezzaRiga ;
	// un trucco per tracciare comunque una pagina
	if ( curAltezzaPagina < 1 )	curAltezzaPagina = 1 ;
	// ecco la pagina da stampare
	lr = NSMakeRect( 0, dimpage , larghezzaPagina, curAltezzaPagina ) ;
	// una strana porcheria per correggere le stampe ingrandite
	if ( scaleFactor > 1 )
	{
		lr.size.height *= scaleFactor ;
		lr.size.width *= scaleFactor ;
	}
	curPageNum = page ;
    return ( lr );
}
#endif

#if		( ! (TEST_03))
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// opzionale, chiamato prima del disegno di ogni pagina, permette il
// disegno di header e footer
- (void)
drawPageBorderWithSize:(NSSize)borderSize
{
	NSRect			circrect ;
	NSString		* str1, * str2 ;
	NSBezierPath	* cnt  ;
	float			vertStrOff ;
	float			invSF = 1 / scaleFactor ;
	// qui e' gia' attiva la trasformazione di scala
	// metto da parte il frame corrente della vista
	NSRect			prevFrame = [ self frame ];
	// per tenere conto del fattore di scala, faccio finta di avere
	// a disposizione una pagina piu' grande...
	float			tm = pageMargins.origin.y * invSF;
	float			lm = pageMargins.origin.x * invSF;
	// una trasformazione per spostare i disegni delle viste
	NSAffineTransform	* tf = [ NSAffineTransform transform ] ;
	float		headHeight = [ [ v2p headerView ] frame ].size.height ; 

	// un rettangolo che contiene tutta la pagina
	circrect = NSMakeRect(lm, tm - headHeight, 
			larghezzaPagina, curAltezzaPagina + headHeight ) ;
	circrect = NSInsetRect( circrect, -1, -1) ;
	cnt = [NSBezierPath bezierPathWithRect: circrect ];
	// produco la stringa col numero di pagina
	str1 = [ NSString stringWithFormat: @"Page %d of %d", 
				curPageNum, totPageNum ] ;
	str2 = [ NSString stringWithString: [[ v2p window] title ]] ;

	// primo blocco di disegno, imposto come frame tutta la pagina
	// (tengo conto della scala) per disegnare un bel contorno
	[ self setFrame: NSMakeRect( 0, 0, borderSize.width * invSF, 
									   borderSize.height * invSF ) ] ;
	// comincio il disegno del primo blocco
	[ self lockFocus ] ;
	// riempio giusto per vedere
	[[ NSColor blueColor] set ]; NSRectFill( circrect );
	// e traccio giusto per evidenziare
	[ [ NSColor redColor] set ]; [ cnt setLineWidth: 1 ]; [ cnt stroke ];
	// cambio la scala
	[ tf scaleBy: invSF ] ;
	[ tf concat ] ;
	// adesso il frame e' tutta la pagina (non chiedete...)
	[ self setFrame: NSMakeRect( 0, 0, borderSize.width, borderSize.height) ] ;
	// come footer il numero il pagina
	vertStrOff = pageMargins.origin.y + altezzaPagina * scaleFactor + 3 ;
	circrect = NSMakeRect(pageMargins.origin.x, vertStrOff, 
						larghezzaPagina * scaleFactor, 25 ) ;
	[ str1  drawInRect:circrect  withAttributes: nil ] ;
	// come header, il nome del catalogo
	vertStrOff = pageMargins.origin.y - headHeight * scaleFactor - 20 ;
	circrect = NSMakeRect(pageMargins.origin.x, vertStrOff, 
						larghezzaPagina * scaleFactor, 25 ) ;
	[ str2  drawInRect:circrect withAttributes: nil ] ;
	// rispristino la scala per le successive operazioni
	[ tf scaleBy: scaleFactor ] ;
	// fine primo blocco di disegno
	[ self unlockFocus ] ;

	// secondo blocco, cambio il frame per disegnare l'intestazione
	[ self setFrame: NSMakeRect( lm, borderSize.height * invSF - tm,
				borderSize.width * invSF - 2*lm, tm ) ] ;
	[ self lockFocus ] ;
	// sposto l'origine per disegnare lo header (un po' piu' su)
	[ tf translateXBy: 0 yBy: tm - headHeight ] ;
	[ tf concat ] ;
	// disegno lo header
	[ [ v2p headerView ] drawRect: [ self bounds] ];
	[ self unlockFocus ] ;
	// ripristino il frame iniziale
	[ self setFrame: prevFrame ] ;
	return ;
}
#endif

#if		( ! (TEST_01))
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// chiamato prima di ogni pagina, per predisporre il contesto grafico
- (void)
beginPageInRect:(NSRect)aRect atPlacement:(NSPoint)location
{
	float				pageOffset ;
	NSAffineTransform	* tf = [ NSAffineTransform transform ] ;
	[ super beginPageInRect: aRect atPlacement: location ] ;
	// per qualche motivo, la trasformazione operata dalla superclasse
	// non va per nulla bene, mi tocca inventarne una da me
	pageOffset = curPageNum * altezzaPagina * scaleFactor ;
	// l'origine e' il punto in basso a sinistra della pagina
	// mi sposto in alto a sinistra, tenendo conto del margine
	[ tf translateXBy: pageMargins.origin.x 
				  yBy: (pageOffset + pageMargins.size.height) ] ;
	// cambio la scala e rovescio l'asse delle y
	[ tf scaleXBy: scaleFactor yBy: -scaleFactor ] ;
	[ tf set ] ;
}
#endif

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// a quanto pare, succedono delle cose bizzare a diversi fattori di scala
// se paginazione standard (e quindi non ci sono i tre metodi qui sopra), 
// allora drawRect ha la scalatura gia' pronta
// se c'e' paginazione proprietaria, drawRect non ha la scalatura pronta
// allora devo inserire una trasformazione, attraverso il metodo precednete

- (void)
drawRect: (NSRect) rect
{
#if		( ! (TEST_02))
#if		TEST_01
	NSAffineTransform	* tf = [ NSAffineTransform transform ] ;
	[ tf scaleBy: scaleFactor ] ;
	[ tf concat ] ;
#endif
#endif
	// c'e' solo la outline da disegnare...
	[ v2p drawRect: rect ] ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
endDocument
{
	[ super endDocument ] ;
	// rimetto a posto la outlineView
	[ self prepareViewForPrinting: NO ] ;
}

// ---------------------------------------------------------------------
- (void)
calcPrintValues 
{
	NSSize			dimPagStampa ;
	// aggiusto le dimensioni della outlineView per
	// comprendere solo fino all'ultima colonna utile
	NSRect			cr = [ v2p rectOfColumn: ([ v2p numberOfColumns] - 1 ) ] ;
	float			larghOutline = cr.origin.x + cr.size.width ;
    // Obtain the print info object for the current operation
    NSPrintInfo *pi = [[NSPrintOperation currentOperation] printInfo];
    // Calculate the page height in points
    NSSize paperSize = [pi paperSize];
    float pageHeight = paperSize.height - [pi topMargin] - [pi bottomMargin];
    float pageWidth = paperSize.width - [pi leftMargin] - [pi rightMargin];
	pageMargins = NSMakeRect( [pi leftMargin], [pi topMargin], 
							 [pi rightMargin], [pi bottomMargin] );
    // Convert height to the scaled view 
    scaleFactor = [[[pi dictionary] objectForKey:NSPrintScalingFactor]
                    floatValue];
	dimPagStampa.height =  pageHeight / scaleFactor; ;
	dimPagStampa.width =  pageWidth / scaleFactor;
	
	// scelgo come larghezza la minima tra stamap e outline
	if ( dimPagStampa.width <= larghOutline )
			larghezzaPagina = dimPagStampa.width ;
	else	larghezzaPagina = larghOutline ;
	// calcolo quando spazio occupa in verticale una riga
	altezzaRiga = [ v2p rowHeight ] + [ v2p intercellSpacing ].height ;
	// calcolo quante righe ci stanno in una pagina
	// tengo conto del fattore di scala...
	righePerPagina = dimPagStampa.height / altezzaRiga ;
	// nuovo valore per l'ampiezza pagina
	altezzaPagina = righePerPagina * altezzaRiga ;
	// e per il margine inferiore (un po' piu' grande)
	pageMargins.size.height += (dimPagStampa.height - altezzaPagina) * scaleFactor ;
	// calcolo quante sono le righe totali da stamapre
	righeDaStampare = [ v2p numberOfRows ] ;
	// basta adesso fare una divisione intera
	totPageNum = righeDaStampare / righePerPagina + 1 ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// adatto la rappresentazione della outlineView alle esigenze di stampa
- (void )
prepareViewForPrinting: (BOOL) toPrint
{
	if ( toPrint )
	{
		// blocco l'aggiornamento della finestra
		[ [ v2p window] setAutodisplay: NO ] ;
		// adatto la vista ad una situazioen di stampa
		setupColumn( v2p, FALSE, COLID_ADD2PRINT );
		[ v2p setUsesAlternatingRowBackgroundColors: NO ] ;
		[ v2p setGridStyleMask: 
				(NSTableViewSolidVerticalGridLineMask | 
				NSTableViewSolidHorizontalGridLineMask ) ] ;
	}
	else
	{
		// rispristino la situazione precedente
		setupColumn( v2p, TRUE, COLID_ADD2PRINT );
		[ v2p setUsesAlternatingRowBackgroundColors: YES ] ;
		[ v2p setGridStyleMask: NSTableViewSolidVerticalGridLineMask ] ;
		[ [ v2p window] setAutodisplay: YES ] ;
	}
}
// ---------------------------------------------------------------------
// per rovesciare l'asse delle ordinate
- (BOOL)
isFlipped
{
	return YES;
}

@end
