// -----------------------------------------------------------------------------
//  UserPrefs.h
//  CdCat2
//  Livio Sandel, No Copyright 2004.
//
// Interfaccia della classe per la gestione delle preference

#import 	<Cocoa/Cocoa.h>

// notifica di aggiornamento rpeferenze
#define		PREF_UPDATE_NOTIFICATION	@"PrefsUpdateNotification"

// chiavi nel dizionario delle preferenze
#define 	keyExpandBundle 	@"ExpandBundle"
#define 	keyShowDotFiles		@"ShowDotFiles"
#define 	keyColModDate		@"ColModDate"
#define 	keyColCreatDate		@"ColCreatDate"
#define 	keyColFileSize		@"ColFileSize"
#define 	keyColGroupName		@"ColGroupName"
#define 	keyColOwnerName		@"ColOwnerName"
#define 	keyColPosixPerm		@"ColPosixPerm"
#define 	keyColCreator		@"ColCreator"
#define 	keyColOSType		@"ColOSType"

#define		keyCDLCW_Filename		@"CDLCW_Filename"
#define		keyCDLCW_ModDate		@"CDLCW_ModDate"
#define		keyCDLCW_CreatDate		@"CDLCW_CreatDate"
#define		keyCDLCW_FileSize		@"CDLCW_FileSize"
#define		keyCDLCW_GroupName		@"CDLCW_GroupName"
#define		keyCDLCW_OwnerName		@"CDLCW_OwnerName"
#define		keyCDLCW_PosixPerm		@"CDLCW_PosixPerm"
#define		keyCDLCW_Creator		@"CDLCW_Creator"
#define		keyCDLCW_OSType			@"CDLCW_OSType"

@interface UserPrefs : NSObject
{
	// valori correnti delle preferenze
	NSMutableDictionary 		*defCurrValues;
}
// metodi (fintamente) di classe per la gestione
// recupero di un valore di una preferenza
+ (id)		getPrefValue: (id) key ;
+ (id)		getSinglePrefValue: (id) key ;
+ (void)	setSinglePrefValue: (id) val forKey:  (id) key ;
// per avere l'intero dizionario delle preferenze
+ (NSMutableDictionary*) getPrefs ;
// per caricare i default dal file
+ (void)	loadPrefsFromDefault ;
// per salvare i default su file
+ (void)	savePrefsToDefault: ( NSMutableDictionary*) newPref ;

// metodi interni di utilita'
// inizializzazione della classe/istanza
- (id)		init ;
// metodi accessor
- ( NSMutableDictionary*) defCurrValues ;
- (void) 	setDefCurrValues: ( NSMutableDictionary*) newPref ;

@end
